#include <fstream>
#include <string>

ifstream in("dreisam.in");

#define LEFTP -1
#define RIGHTP -2
#define MUL -3
#define ADD -4
#define SUB -5
#define OP -6
#define NOTHING -10

char a[100];
int b[100];
int bn;
int left;
int apos;
int bpos;
int r[100];
char ch;
string s;
int nop;
int op[30];
int possible;
int kase;

void skipws() {
  while (a[apos] && !isdigit(a[apos]) && a[apos] != '(' && a[apos] != ')' && a[apos] != '=')
    apos++;
}
  
int getnumber() {
  int ret = a[apos++]-'0';
  while (isdigit(a[apos])) {
    ret *= 10;
    ret += a[apos++]-'0';
  }
  return ret;
}

int eval();

int getterm() {
  int ret; 
  if (b[bpos] == LEFTP) {
    bpos++;
    ret = eval();
    bpos++; // rechte Klammer
  }
  else
    ret = b[bpos++];
  return ret;
}

int eval() {
  int ret = getterm();
  //  cout << "ret = " << ret << endl;
  while (b[bpos] == MUL || b[bpos] == ADD || b[bpos] == SUB) {
    int operation = b[bpos++];
    int ret2 = getterm();
    //    cout << "ret2 = " << ret2 << endl;
    switch  (operation) {
    case MUL: ret *= ret2; break;
    case ADD: ret += ret2; break;
    case SUB: ret -= ret2; break;
    }
  }
  return ret;
}

void print(int *);

void generate(int l) {
  if (possible)
    return;
  if (l==nop) {
    bpos = 0;
    //    print(b);
    int tt = eval();
    //    cout << " EVAL = " << tt << endl;
    if (tt == left) {
      possible = 1;
      for (int i=0; i<bn; i++)
	r[i] = b[i];
    }
    return;
  }
  
  b[op[l]] = MUL; generate(l+1);
  b[op[l]] = ADD; generate(l+1);
  b[op[l]] = SUB; generate(l+1);
}

void print(int *q) {
  cout << left << "=";
  for (int i=0; i<bn; i++)
    switch (q[i]) {
    case ADD: cout << "+"; break;
    case MUL: cout << "*"; break;
    case SUB: cout << "-"; break;
    case LEFTP: cout << "("; break;
    case RIGHTP: cout << ")"; break;
    case OP: cout << "?"; break;
    default: cout << q[i]; break;
    }
}

int main() {
  kase = 0;
  while (1) {
    possible = 0;
    for (int i=0; i<90; i++)
      b[i] = NOTHING;

    apos = 0;
    in.getline(a,83);
    skipws();
    left = getnumber();
    skipws();
    if (a[apos] != '=')
      break;
    apos++;
    skipws();
    
    bn = 0;
    nop = 0;
    while (1) {
      skipws();
      if (!a[apos])
	break;        // Ende der Zeile

      if (a[apos] == '(') {
	b[bn++] = LEFTP;
	apos++;
	continue;
      }
      if (a[apos] == ')') {
	b[bn++] = RIGHTP;
	apos++;
      }
      else
	b[bn++] = getnumber();
      skipws();
      if (a[apos] && a[apos] != ')') {
	op[nop++] = bn;
	b[bn++] = OP;
      } 
    }

    //    cout << nop << endl;
    //    print(b); cout << endl;

    generate(0);
    cout << "Equation #" << ++kase <<":"<<endl;
        
    if (bn==1 && left == b[0]){
      cout << left << "=" << left << endl;
    }
    else if (bn==0 || !possible) {
      cout << "Impossible" << endl;
    }
    else {
      print(r);
      cout << endl;
    }
    cout << endl;
  }
  return 0;
}
